// systeme solaire avec gravite
// 3D avec peasycam
import peasy.*;
PeasyCam cam;


planete[] p = new planete[1000];
float xsol = 300;
float ysol = 300;
float zsol = 0;
float dt=1.0;

void setup(){
  size(600,600,P3D);
  sphereDetail(10);
  //noStroke();
  cam = new PeasyCam(this, 300,300,0,500);
  cam.setMinimumDistance(100);
  cam.setMaximumDistance(1000);

  for (int i=0;i<p.length;i++) p[i] = new planete();
}

void draw(){
  background(128);
  // le soleil au centre de la scene
  pushMatrix();
  translate(xsol,ysol,zsol);
  sphere(50);
  popMatrix();
  // les planetes
  for (int i=0;i<p.length;i++)p[i].dessin();
  for (int i=0;i<p.length;i++)p[i].evolution();
}

class planete {
  float x,y,z;
  float vx,vy,vz;
  float ax,ay,az;
  float xp,yp,zp;
  float dia;
  planete(){
    x=random(-600,600);
    y=random(-600,600);
    z=0; //random(-600,600);
    float d = sqrt((x-xsol)*(x-xsol)+(y-ysol)*(y-ysol));
    vx=-40*(y-ysol)/sqrt(d*d*d);
    vy=40*(x-xsol)/sqrt(d*d*d);
    vz=0; 
    dia=random(5,20);
    xp = x; yp = y; zp = z;
  }

  void evolution(){
   float dist2 = (x-xsol)*(x-xsol)+(y-ysol)*(y-ysol)+(z-zsol)*(z-zsol);
   if (dist2>25*25){ // si dist<rayon soleil alors la planete tombe dans le soleil
   float attraction = 10/dist2;
   xp = x; yp = y; zp = z;
   ax = attraction*(xsol-x);
   ay = attraction*(ysol-y);
   az = attraction*(zsol-z);
   vx = vx + dt*ax;
   vy = vy + dt*ay;
   vz = vz + dt*az;
   x = x + dt*vx;
   y = y + dt*vy;
   z = z + dt*vz;
   }
  }
  
  void dessin(){
   pushMatrix();
   translate(x,y,z);
   sphere(dia);
   popMatrix();
   //line(xp,yp,zp,x,y,z);
  }  
}
  